<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_2</title>
</head>
<body>
    <h1>Capitulo 2</h1>
    <a>Ejercicio 6</a>

    <script>

class Node {
    constructor(val) {
        this.data = val;
        this.next = null;
    }
}

//Función Invertir lista
function invertir(node) {
    var prev = null,
     current = node,
        next = null;
    while (current != null) {
        next = current.next;
        current.next = prev;
        prev = current;
        current = next;
    }
    return prev;
}

//Función que verifica si es palindromo lista
function palindromo(node) {
    let slow = node,
        palind = true,
        stack   = [];

    while (slow != null) {
        stack.push(slow.data);
        slow = slow.ptr;
    }

    while (node != null) {
        let i = stack.pop();
        if (node.data === i) {
            palind = true;
        } else {
            palind = false;
        }
        node = node.ptr;
    }
    return palind;
}

function imprimirList(node) {
    while (node !== null) {
        console.log( node.data + " ");
        node = node.next
    }
}

let head1 = new Node(1),
    head2 = new Node(2),
    head3 = new Node(3),
    head4 = new Node(3);
    head5 = new Node(2);
    head6 = new Node(1);

head1.ptr = head2;
head2.ptr = head3;
head3.ptr = head4;
head4.ptr = head5;
head5.ptr = head6;

let num = palindromo(head1);
if(num) {
    console.log(`La lista "SI" es un Palindromo`);    
} else {
    console.log(`La lista "NO" es un Palindromo`); 
}
    </script>
    
</body>
</html>